From 04376c7d94d2331f1851ea4563c8920e1b6335a0 Mon Sep 17 00:00:00 2001
From: David Tolnay <dtolnay@gmail.com>
Date: Mar 26 2021 21:08:48 +0000
Subject: [PATCH 2200/2232] Permit mut from ref in unsafe-to-call signatures


---

diff --git a/syntax/check.rs b/syntax/check.rs
index 6ba6565..1e52c2e 100644
--- a/syntax/check.rs
+++ b/syntax/check.rs
@@ -508,6 +508,11 @@ fn check_api_impl(cx: &mut Check, imp: &Impl) {
 }
 
 fn check_mut_return_restriction(cx: &mut Check, efn: &ExternFn) {
+    if efn.sig.unsafety.is_some() {
+        // Unrestricted as long as the function is made unsafe-to-call.
+        return;
+    }
+
     match &efn.ret {
         Some(Type::Ref(ty)) if ty.mutable => {}
         _ => return,
diff --git a/tests/ui/mut_return.stderr b/tests/ui/mut_return.stderr
index 6b091d7..d6ddb88 100644
--- a/tests/ui/mut_return.stderr
+++ b/tests/ui/mut_return.stderr
@@ -3,9 +3,3 @@ error: &mut return type is not allowed unless there is a &mut argument
   |
 6 |         fn f(t: &Thing) -> Pin<&mut CxxString>;
   |         ^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
-
-error: &mut return type is not allowed unless there is a &mut argument
- --> $DIR/mut_return.rs:7:9
-  |
-7 |         unsafe fn g(t: &Thing) -> Pin<&mut CxxString>;
-  |         ^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^

